export type TWeapon = {
    armorPenetration : number, // number between 0 and 1;
    damageDropOff : number, // reduce x damage per block traveled
    damage: number,
    maxRange: number,
    knockback ?: {
        x: number, // knockback in blocks
        y: number // knockback in blocks
    } // knockback in blocks // knockback in blocks
}

export const Instances : Record<string, TWeapon> = {
    arrow : {
        armorPenetration: 0.2,
        damageDropOff: 2,
        damage: 200,
        maxRange: 2,
        knockback : {
            x: 0.5,
            y: 0.5
        }
    },
    ak47: {
        armorPenetration: 0.2,
        damageDropOff: 1,
        damage: 100,
        maxRange: 90,
    },
    g3sg1: {
        armorPenetration: 0.15,
        damageDropOff: 0.015,
        damage: 13,
        maxRange: 120
    },
    m4a1: {
        armorPenetration: 0.18,
        damageDropOff: 0.02,
        damage: 12,
        maxRange: 85
    },
    sg550: {
        armorPenetration: 0.15,
        damageDropOff: 0.02,
        damage: 12,
        maxRange: 100
    },
    an94: {
        armorPenetration: 0.17,
        damageDropOff: 0.015,
        damage: 12,
        maxRange: 85
    },
    m16a4: {
        armorPenetration: 0.16,
        damageDropOff: 0.02,
        damage: 13,
        maxRange: 95
    },
    jackhammer: {
        armorPenetration: 0.05,
        damageDropOff: 0.03,
        damage: 4,
        maxRange: 20
    },
    striker: {
        armorPenetration: 0.12,
        damageDropOff: 0.025,
        damage: 15,
        maxRange: 30
    },
    hk416: {
        armorPenetration: 0.14,
        damageDropOff: 0.02,
        damage: 10,
        maxRange: 80
    },
    aug: {
        armorPenetration: 0.14,
        damageDropOff: 0.02,
        damage: 10,
        maxRange: 85
    },
    tar: {
        armorPenetration: 0.12,
        damageDropOff: 0.02,
        damage: 9,
        maxRange: 80
    },
    fnc: {
        armorPenetration: 0.11,
        damageDropOff: 0.025,
        damage: 9,
        maxRange: 75
    },
    db: {
        armorPenetration: 0.08,
        damageDropOff: 0.03,
        damage: 6,
        maxRange: 20
    },
    slash: {
        armorPenetration: 0.05,
        damageDropOff: 0.05,
        damage: 8,
        maxRange: 5
    },
    m107: {
        armorPenetration: 0.3,
        damageDropOff: 0.005,
        damage: 70,
        maxRange: 150
    },
    deagle: {
        armorPenetration: 0.25,
        damageDropOff: 0.01,
        damage: 13,
        maxRange: 50
    },
    automag: {
        armorPenetration: 0.22,
        damageDropOff: 0.015,
        damage: 10,
        maxRange: 50
    },
    usp: {
        armorPenetration: 0.1,
        damageDropOff: 0.025,
        damage: 8,
        maxRange: 40
    },
    glock: {
        armorPenetration: 0.05,
        damageDropOff: 0.03,
        damage: 5,
        maxRange: 35
    },
    glockb: {
        armorPenetration: 0.05,
        damageDropOff: 0.03,
        damage: 4,
        maxRange: 35
    },
    slash2: {
        armorPenetration: 0.15,
        damageDropOff: 0.02,
        damage: 57,
        maxRange: 15
    },
    tmp: {
        armorPenetration: 0.1,
        damageDropOff: 0.04,
        damage: 4,
        maxRange: 35
    },
    m1911: {
        armorPenetration: 0.18,
        damageDropOff: 0.02,
        damage: 7,
        maxRange: 40
    },
    ump45: {
        armorPenetration: 0.12,
        damageDropOff: 0.025,
        damage: 9,
        maxRange: 45
    },
    k1a: {
        armorPenetration: 0.13,
        damageDropOff: 0.02,
        damage: 7,
        maxRange: 40
    },
    mp7a1: {
        armorPenetration: 0.1,
        damageDropOff: 0.025,
        damage: 8,
        maxRange: 45
    },
    mp5: {
        armorPenetration: 0.1,
        damageDropOff: 0.03,
        damage: 7,
        maxRange: 40
    },
    winchester: {
        armorPenetration: 0.08,
        damageDropOff: 0.04,
        damage: 4,
        maxRange: 30
    },
    xm: {
        armorPenetration: 0.06,
        damageDropOff: 0.03,
        damage: 5,
        maxRange: 25
    },
    ksg: {
        armorPenetration: 0.06,
        damageDropOff: 0.04,
        damage: 4,
        maxRange: 25
    },
    spas: {
        armorPenetration: 0.07,
        damageDropOff: 0.03,
        damage: 4,
        maxRange: 30
    },
    akm: {
        armorPenetration: 0.18,
        damageDropOff: 0.02,
        damage: 12,
        maxRange: 90
    },
    galil: {
        armorPenetration: 0.16,
        damageDropOff: 0.025,
        damage: 11,
        maxRange: 85
    },
    famas: {
        armorPenetration: 0.15,
        damageDropOff: 0.02,
        damage: 9,
        maxRange: 80
    },
    famasb: {
        armorPenetration: 0.16,
        damageDropOff: 0.02,
        damage: 10,
        maxRange: 80
    },
    ultimax: {
        armorPenetration: 0.14,
        damageDropOff: 0.025,
        damage: 10,
        maxRange: 85
    },
    m249: {
        armorPenetration: 0.2,
        damageDropOff: 0.015,
        damage: 12,
        maxRange: 90
    },
    p90: {
        armorPenetration: 0.1,
        damageDropOff: 0.03,
        damage: 6,
        maxRange: 40
    },
    sr3m: {
        armorPenetration: 0.13,
        damageDropOff: 0.02,
        damage: 7,
        maxRange: 40
    },
    tempest: {
        armorPenetration: 0.07,
        damageDropOff: 0.03,
        damage: 5,
        maxRange: 30
    }
};
